---
apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ .Release.Name }}-fix-missing-end-date-alarms
  labels:
    {{- include "fix-missing-end-date-alarms.labels" . | nindent 4 }}
data:
  requirements.txt: |-
    psycopg2-binary
    python-dotenv==1.0.0
    SQLAlchemy==2.0.37
    pytz
  main.py: |-
    import os

    import sqlalchemy as sa
    from dotenv import load_dotenv
    from os.path import join, dirname
    from sqlalchemy import text
    import time
    import logging

    path = join(dirname(__file__), '.env')
    load_dotenv(path)

    logging.basicConfig(
        format='%(asctime)s %(levelname)-8s %(message)s',
        level="INFO",
        datefmt='%Y-%m-%d %H:%M:%S')


    def get_alarms(ids):
        engine = sa.create_engine(os.environ.get("DB_ALARMENSERVICE_URL"))
        with engine.connect() as conn:
            try:
                logging.info('Getting alarms..')
                stmt = text('SELECT uuid, end_date FROM alarms WHERE uuid IN :ids')
                curr = conn.execute(stmt, {'ids': tuple(ids)})
                alarms = curr.fetchall()
                curr.close()
                return alarms
            except Exception as e:
                logging.exception(e)


    def get_afspraken():
        engine = sa.create_engine(os.environ.get("DB_HUISHOUDBOEKJESERVICE_URL"))
        with engine.connect() as conn:
            try:
                logging.info('Getting afspraken..')
                curr = conn.execute(text(
                    'SELECT alarm_id, valid_through FROM afspraken WHERE alarm_id IS NOT NULL AND valid_through IS NOT NULL'))
                afspraken = curr.fetchall()
                curr.close()
                return afspraken
            except Exception as e:
                logging.exception(e)


    def update_alarms_enddate():
        afspraken = get_afspraken()
        ids = []
        for afspraak in afspraken:
            (id, einddatum) = afspraak
            ids.append(id)

        logging.info(f"Totaal afspraken met alarm en einddatum: {len(afspraken)}")

        alarms = get_alarms(ids)

        alarms_with_wrong_end_date = []
        alarm_lookup = {str(alarm[0]): alarm[1] for alarm in alarms}
        agreement_lookup = {afspraak[0]: afspraak[1] for afspraak in afspraken}
        now = int(time.time())

        incorrect_ids = []
        didnt_exist_ids = []
        for afspraak in afspraken:
            (alarm_id, valid_through) = afspraak
            endDate = alarm_lookup.get(alarm_id, -1)
            if endDate != -1:
                valid_through = int(valid_through.timestamp())
                if endDate != valid_through:
                    incorrect_ids.append(alarm_id)
                    if valid_through < now:
                        alarms_with_wrong_end_date.append((alarm_id, valid_through, False))
                    else:
                        alarms_with_wrong_end_date.append((alarm_id, valid_through, True))
            else:
                didnt_exist_ids.append(alarm_id)

        engine = sa.create_engine(os.environ.get("DB_ALARMENSERVICE_URL"))
        total = len(alarms_with_wrong_end_date)
        values_clause = ", ".join([f"('{alarm_id}', {end_date}, {str(is_active).upper()})"
                                   for alarm_id, end_date, is_active in alarms_with_wrong_end_date])
        logging.info(f"Aantal alarmen om te updaten: {total}")
        with engine.begin() as conn:
            if total > 0:
                stmt = text(
                    f"""
                    WITH temp_alarm_updates (alarm_id, end_date, active) AS ( VALUES {values_clause} )
                    UPDATE alarms
                    SET end_date = t.end_date , is_active = t.active
                    FROM temp_alarm_updates t
                    WHERE alarms.uuid = t.alarm_id::uuid
                    """)
                conn.execute(stmt)
                logging.info("alarms geupdate, nu signals updaten")
                stmt = text("""
                    UPDATE signals SET is_active = false WHERE alarm_uuid IN :ids
                    """)
                conn.execute(stmt, {'ids': tuple(incorrect_ids)})
                conn.commit()
                conn.close()
            logging.info(f"de volgende alarmen bestonden niet:")
            logging.info(didnt_exist_ids)
            logging.info("done")



    update_alarms_enddate()
